package com.acme;

public class UIComponentRenderer extends javax.faces.render.Renderer
{
    private static org.slf4j.Logger _log = org.slf4j.LoggerFactory.getLogger( UIComponentRenderer.class );

    public UIComponentRenderer()
    {
        super();
    }

    public void encodeEnd( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component ) throws java.io.IOException
    {
        Object myidObj = component.getAttributes().get( "myid" );
        Integer myid = null;
        if( myidObj instanceof java.lang.Integer )
        {
            myid = (Integer)myidObj;
        }
        else if( myidObj instanceof java.lang.String )
        {
            try
            {
                myid = new Integer( (String)myidObj );
            }
            catch( Exception e )
            {
                _log.warn( "Problem converting to Integer " + myidObj );
            }
        }
        _log.trace( "encodeEnd: " + myid );

        if( myid != null )
        {
            javax.faces.context.ResponseWriter writer = context.getResponseWriter();
            writer.write( renderIt( context, component ) );
            //renderIt( context, component );
        }
    }

    private String renderIt( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component ) throws java.io.IOException
    {
        javax.faces.context.ResponseWriter outputWriter = context.getResponseWriter();
        java.io.StringWriter stringWriter = new java.io.StringWriter();
        javax.faces.context.ResponseWriter writer = outputWriter.cloneWithWriter( stringWriter );

        //javax.faces.context.ResponseWriter writer = context.getResponseWriter();

        writer.write( "<br/>\n" );
        writer.startElement( "img", component );
        writer.writeAttribute( "src", "http://www.google.com/intl/en_ALL/images/logo.gif", null );
        writer.writeAttribute( "border", "0", null );
        writer.writeAttribute( "hspace", "10", null );
        writer.endElement( "img" );

        writer.write( "<br/>\n" );
        writer.startElement( "h2", component );
        writer.startElement( "a", component );
        writer.writeAttribute( "href", "http://www.google.com", null );
        writer.writeAttribute( "target", "_blank", null );
        writer.writeText( "Yahoo", "type" );
        writer.endElement( "a" );

        writer.endElement( "h2" );

        writer.flush();
        stringWriter.flush();
        return( stringWriter.getBuffer().toString() );
        //return( "" );

    }
}
